\ProvidesPackage{cake}

\RequirePackage{kvoptions} % Handle package options
\SetupKeyvalOptions{
    family = kaotheorems,
    prefix = kaotheorems@
}

\DeclareBoolOption{framed}

\newcommand{\kaotheorems@defaultbg}{Goldenrod!45!white}
\newcommand{\kaotheorems@exercisepromptbg}{RawSienna!70!black}
\newcommand{\kaotherems@exercisecorrectionbg}{NavyBlue!70!black}

\DeclareStringOption[\kaotheorems@exercisepromptbg]{exercisebackground}
\DeclareStringOption[\kaotheorems@correctionbg]{correctionbackground}
\DeclareStringOption[\kaotheorems@defaultbg]{background}
\DeclareStringOption[\kaotheorems@defaultbg]{theorembackground}
\DeclareStringOption[\kaotheorems@defaultbg]{propositionbackground}
\DeclareStringOption[\kaotheorems@defaultbg]{lemmabackground}
\DeclareStringOption[\kaotheorems@defaultbg]{corollarybackground}
\DeclareStringOption[\kaotheorems@defaultbg]{definitionbackground}
\DeclareStringOption[\kaotheorems@defaultbg]{assumptionbackground}
\DeclareStringOption[\kaotheorems@defaultbg]{remarkbackground}
\DeclareStringOption[\kaotheorems@defaultbg]{examplebackground}
\DeclareStringOption[\kaotheorems@defaultbg]{axiombackground}

\ProcessKeyvalOptions{kaotheorems}

\let\openbox\relax
\RequirePackage{amsmath} % Improved mathematics
\RequirePackage{amsthm} % Mathematical environments
\RequirePackage{thmtools} % Theorem styles

\ifkaotheorems@framed%
    \RequirePackage{tikz} % Colorful boxes
    \RequirePackage[framemethod=TikZ]{mdframed}

    % Box style
    \mdfsetup{skipabove=\topskip,skipbelow=0pt}%-.5\topskip}
    \mdfdefinestyle{mdfkao}{
    	skipabove=\topskip,
    	skipbelow=\topskip, % Does not work :(
    	rightmargin=0pt,
    	leftmargin=0pt,
    	innertopmargin=7pt,
    	innerbottommargin=3pt,
    	innerrightmargin=5pt,
    	innerleftmargin=5pt,
    	topline=false,
    	bottomline=false,
    	rightline=false,
    	leftline=false,
    	%linewidth=1pt,
    	%roundcorner=0pt,
    	%font={},
    	%frametitlefont={},
    	frametitlerule=true,
    	%linecolor=black,
    	%backgroundcolor=LightBlue,
    	%fontcolor=black,
    	%frametitlebackgroundcolor=LightBlue,
    }

    % Theorem styles
    \declaretheoremstyle[
    	%spaceabove=.5\thm@preskip,
    	%spacebelow=.5\thm@postskip,
    	%headfont=\normalfont\bfseries,%\scshape,
    	%notefont=\normalfont, notebraces={ (}{)},
    	bodyfont=\normalfont\itshape,
    	%headformat={\NAME\space\NUMBER\space\NOTE},
    	headpunct={},
    	%postheadspace={.5em plus .1em minus .1em},
    	%prefoothook={\hfill\qedsymbol}
    ]{kaoplain}
    \declaretheoremstyle[
    	%spaceabove=.5\thm@preskip,
    	%spacebelow=.5\thm@postskip,
    	%headfont=\normalfont\bfseries,%\scshape,
    	%notefont=\normalfont, notebraces={ (}{)},
    	bodyfont=\normalfont\itshape,
    	%headformat={\NAME\space\NUMBER\space\NOTE},
    	headpunct={},
    	postheadspace={.5em plus .1em minus .1em},
    	%prefoothook={\hfill\qedsymbol}
    ]{kaodefinition}
    \declaretheoremstyle[
    	%spaceabove=.5\thm@preskip,
    	%spacebelow=.5\thm@postskip,
    	%headfont=\normalfont\bfseries,%\scshape,
    	%notefont=\normalfont, notebraces={ (}{)},
    	bodyfont=\normalfont\itshape,
    	%headformat={\NAME\space\NUMBER\space\NOTE},
    	headpunct={},
    	postheadspace={.5em plus .1em minus .1em},
    	%prefoothook={\hfill\qedsymbol}
    ]{kaoassumption}
    \declaretheoremstyle[
    	%spaceabove=.5\thm@preskip,
    	%spacebelow=.5\thm@postskip,
    	%headfont=\normalfont\bfseries,
    	%notefont=\normalfont, notebraces={ (}{)},
    	%bodyfont=\normalfont,
    	%headformat={\footnotesize$\triangleright$\space\normalsize\NAME\space\NUMBER\space\NOTE},
    	%headformat={\NAME\space\NUMBER\space\NOTE},
    	headpunct={},
    	postheadspace={.5em plus .1em minus .1em},
    	%refname={theorem,theorems},
    	%Refname={Theorem,Theorems},
    ]{kaoremark}
    \declaretheoremstyle[
    	%spaceabove=.5\thm@preskip,
    	%spacebelow=.5\thm@postskip,
    	%headfont=\normalfont\bfseries,
    	%notefont=\normalfont, notebraces={ (}{)},
    	%bodyfont=\normalfont,
    	%headformat={\NAME\space\NUMBER\space\NOTE},
    	headpunct={},
    	postheadspace={.5em plus .1em minus .1em},
    	%prefoothook={\hfill\qedsymbol}
    	%refname={theorem,theorems},
    	%Refname={Theorem,Theorems},
    ]{kaoexample}
    \declaretheoremstyle[
    	%spaceabove=.5\thm@preskip,
    	%spacebelow=.5\thm@postskip,
    	%headfont=\normalfont\bfseries,
    	%notefont=\normalfont, notebraces={ (}{)},
    	%bodyfont=\small,
    	%headformat={\NAME\space\NUMBER\space\NOTE},
    	headpunct={},
    	postheadspace={.5em plus .1em minus .1em},
    	%prefoothook={\hfill\qedsymbol}
    	%refname={theorem,theorems},
    	%Refname={Theorem,Theorems},
    ]{kaoexercise}

    \theoremstyle{kaoplain}
    \declaretheorem[
    	name=Theorem,
    	style=kaoplain,
    	%refname={theorem,theorems},
    	refname={Theorem,Theorems},
    	Refname={Theorem,Theorems},
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@theorembackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{theorem}
    \declaretheorem[
    	name=Proposition,
    	%refname={proposition,propositions},
    	refname={Proposition,Propositions},
    	Refname={Proposition,Propositions},
    	sibling=theorem,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@propositionbackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{proposition}
    \declaretheorem[
    	name=Lemma,
    	%refname={lemma,lemmas},
    	refname={Lemma,Lemmas},
    	Refname={Lemma,Lemmas},
    	sibling=theorem,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@lemmabackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{lemma}
    \declaretheorem[
    	name=Corollary,
    	%refname={corollary,corollaries},
    	refname={Corollary,Corollaries},
    	Refname={Corollary,Corollaries},
    	sibling=theorem,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@corollarybackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{corollary}

    \theoremstyle{kaodefinition}
    \declaretheorem[
    	name=Definition,
    	%refname={definition,definitions},
    	refname={Definition,Definitions},
    	Refname={Definition,Definitions},
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@definitionbackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{definition}

    \theoremstyle{kaoassumption}
    \declaretheorem[
    	name=Assumption,
    	%refname={assumption,assumptions},
    	refname={Assumption,Assumptions},
    	Refname={Assumption,Assumptions},
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@assumptionbackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{assumption}

    \theoremstyle{kaoremark}
    \declaretheorem[
    	name=Remark,
    	%refname={remark,remarks},
    	refname={Remark,Remarks},
    	Refname={Remark,Remarks},
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@remarkbackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{remark}

    \theoremstyle{kaoexample}
    \declaretheorem[
    	name=Example,
    	%refname={example,examples},
    	refname={Example,Examples},
    	Refname={Example,Examples},
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
            backgroundcolor=\kaotheorems@examplebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{example}

    \theoremstyle{kaoexercise}
    \declaretheorem[
    	name=Exercice,
    	numberwithin=section,
		refname={Example,Examples},
    	Refname={Example,Examples},
    	mdframed={
    		style=mdfkao,
    		backgroundcolor=\@exercisebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{exercise}

	\theoremstyle{kaoexercise}
    \declaretheorem[
    	name=* Exercice,
    	numberwithin=section,
		refname={Example,Examples},
    	Refname={Example,Examples},
		sibling=exercise,
    	mdframed={
    		style=mdfkao,
    		backgroundcolor=\@exercisebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{exercice-a-rendre}

    \theoremstyle{kaoexercise}
    \declaretheorem[
        name=Solution
		refname={Example,Examples},
    	Refname={Example,Examples},
		sibling=exercise
        mdframed={
    		style=mdfkao,
    		backgroundcolor=\@exercisebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{solution}

    \theoremstyle{kaoexercise}
    \declaretheorem[
        name=Correction
		sibling=exercise,
        mdframed={
    		style=mdfkao,
    		backgroundcolor=\@correctionbackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{correction}

	\declaretheorem[
        name=Axiom,
        %refname={axiom,axioms},
        refname={Axiom,Axioms},
        Refname={Axiom,Axioms},
        sibling=theorem,
        mdframed={
            style=mdfkao,
            backgroundcolor=\kaotheorems@axiombackground,
            %frametitlebackgroundcolor=\@theorembackground,
        },
    ]{axiom}

    %\renewcommand{\thetheorem}{\arabic{chapter}.\arabic{section}.\arabic{theorem}}
    %\renewcommand{\thetheorem}{\arabic{subsection}.\arabic{theorem}}
    %\renewcommand{\qedsymbol}{$\blacksquare$}
\else

    % Theorem styles
    \declaretheoremstyle[
    	spaceabove=.6\thm@preskip,
    	spacebelow=.1\thm@postskip,
    	bodyfont=\normalfont\itshape,
    	headpunct={},
    ]{kaoplain}
    \declaretheoremstyle[
    	spaceabove=.6\thm@preskip,
    	spacebelow=.1\thm@postskip,
    	bodyfont=\normalfont\itshape,
    	headpunct={},
    ]{kaodefinition}
    \declaretheoremstyle[
    	spaceabove=.6\thm@preskip,
    	spacebelow=.1\thm@postskip,
    	headpunct={},
    ]{kaoremark}
    \declaretheoremstyle[
    	spaceabove=.6\thm@preskip,
    	spacebelow=.1\thm@postskip,
    	headpunct={},
    ]{kaoexample}
    \declaretheoremstyle[
    	headpunct={},
    	postheadspace={.5em plus .1em minus .1em},
    ]{kaoexercise}

    \theoremstyle{kaoplain}
    \declaretheorem[
    	name=Théorème,
    	numberwithin=section,
    ]{theorem}
    \declaretheorem[
    	name=Proposition,
    	sibling=theorem,
    ]{proposition}
    \declaretheorem[
    	name=Lemme,
    	sibling=theorem,
    ]{lemma}
    \declaretheorem[
    	name=Corollaire,
    	sibling=theorem,
    ]{corollary}

    \theoremstyle{kaodefinition}
    \declaretheorem[
    	name=Définition,
    	numberwithin=section,
    ]{definition}

    \theoremstyle{kaoremark}
    \declaretheorem[
    	name=Remarque,
    	numberwithin=section,
    ]{remark}

    \theoremstyle{kaoexample}
    \declaretheorem[
    	name=Exemple,
    	numberwithin=section,
    ]{example}

    \theoremstyle{kaoexercise}
    \declaretheorem[
    	name=Exercice,
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
    		backgroundcolor=\@exercisebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{exercice}

    \theoremstyle{kaoexercise}
    \declaretheorem[
    	name=* Exercice,
    	numberwithin=section,
    	mdframed={
    		style=mdfkao,
    		backgroundcolor=\@exercisebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{exercice-a-rendre}

    \theoremstyle{kaosolution}
    \declaretheorem[
        name=Solution
        mdframed={
    		style=mdfkao,
    		backgroundcolor=\@exercisebackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{solution}

    \theoremstyle{kaocorrection}
    \declaretheorem[
        name=Correction
        mdframed={
    		style=mdfkao,
    		backgroundcolor=\@correctionbackground,
    		%frametitlebackgroundcolor=\@theorembackground,
    	},
    ]{correction}

	\theoremstyle{kaodefinition}
    \declaretheorem[
        name=Axiom,
        %refname={axiom,axioms},
        refname={Axiom,Axioms},
        Refname={Axiom,Axioms},
        sibling=theorem,
        mdframed={
            style=mdfkao,
            backgroundcolor=\kaotheorems@axiombackground,
            %frametitlebackgroundcolor=\@theorembackground,
        },
    ]{axiom}

    %\renewcommand{\thetheorem}{\arabic{chapter}.\arabic{section}.\arabic{theorem}}
    %\renewcommand{\thetheorem}{\arabic{subsection}.\arabic{theorem}}
    %\renewcommand{\qedsymbol}{$\blacksquare$}
\fi




% % theorems
% \makeatother
% \usepackage{thmtools}
% \usepackage[framemethod=TikZ]{mdframed}
% \mdfsetup{skipabove=1em,skipbelow=0em}


% \theoremstyle{definition}

% \declaretheoremstyle[
%     % headfont=\bfseries\sffamily\color{ForestGreen!70!black}, 
%     bodyfont=\normalfont,
%     mdframed={
%         linewidth=2pt,
%         rightline=false, topline=false, bottomline=false,
%         linecolor=ForestGreen, backgroundcolor=ForestGreen!5,
%     }
% ]{thmgreenbox}

% \declaretheoremstyle[
%     % headfont=\bfseries\sffamily\color{NavyBlue!70!black}, 
%     bodyfont=\normalfont,
%     mdframed={
%         linewidth=2pt,
%         rightline=false, topline=false, bottomline=false,
%         linecolor=NavyBlue, backgroundcolor=NavyBlue!5,
%     }
% ]{thmbluebox}

% \declaretheoremstyle[
%     % headfont=\bfseries\sffamily\color{NavyBlue!70!black}, 
%     bodyfont=\normalfont,
%     mdframed={
%         linewidth=2pt,
%         rightline=false, topline=false, bottomline=false,
%         linecolor=NavyBlue
%     }
% ]{thmblueline}

% \declaretheoremstyle[
%     % headfont=\bfseries\sffamily\color{RawSienna!70!black}, 
%     bodyfont=\normalfont,
%     mdframed={
%         linewidth=2pt,
%         rightline=false, topline=false, bottomline=false,
%         linecolor=RawSienna, backgroundcolor=RawSienna!5,
%     }
% ]{thmredbox}

% \declaretheoremstyle[
%     % headfont=\bfseries\sffamily\color{RawSienna!70!black}, 
%     bodyfont=\normalfont,
%     numbered=no,
%     mdframed={
%         linewidth=2pt,
%         rightline=false, topline=false, bottomline=false,
%         linecolor=RawSienna, backgroundcolor=RawSienna!1,
%     }
%     % qed=\qedsymbol
% ]{thmproofbox}

% \declaretheoremstyle[
%     % headfont=\bfseries\sffamily\color{NavyBlue!70!black}, 
%     bodyfont=\normalfont,
%     numbered=no,
%     mdframed={
%         linewidth=2pt,
%         rightline=false, topline=false, bottomline=false,
%         linecolor=NavyBlue, backgroundcolor=NavyBlue!1,
%     },
% ]{thmexplanationbox}


% \declaretheorem[style=thmgreenbox, name=Exercice facultatif]{facultatif}
% \declaretheorem[style=thmbluebox, numbered=no, name=Exercice]{exercice}
% \declaretheorem[style=thmredbox, name=Exercice]{obligatoire}
% \declaretheorem[style=thmredbox, name=Lemma]{lemma}
% \declaretheorem[style=thmredbox, numbered=no, name=Corollary]{corollary}

% \declaretheorem[style=thmproofbox, name=Solution]{solution}

% \declaretheorem[style=thmexplanationbox, name=Correction]{correction}

% \declaretheorem[style=thmblueline, numbered=no, name=Remark]{remark}
% \declaretheorem[style=thmblueline, numbered=no, name=Note]{note}